#!/bin/sh
# set -xe
MRUFrep="/usr/local/share/MRUF";MRUF="MRUF-lst";corps="$MRUFrep/corps"
MRUFv=MRUF-lst-0.9.7.7.sh
XBel="/root/.recently-used.xbel";XBelChecK="/root/.local/share/recently-used.xbel"
[ -f $MRUFrep/FirstRun ] && Get-Gtk-Theme.sh && exit
####
case "$@" in
	A|a|H|h)TitrE="################# /usr/local/bin/$MRUFv ###################"
	ExecS="aemenu-pango & bcm (vovchik), bash (v. >= 4.3; Fox & al.), less
   # (Greenwood), replaceit (Daniels), sfs_load (shinobar), UExtract (SFR),
   # urxvt (v. >= 9.2; Lehmann & al.)."
	DonneeS=".mtpaint, (.)recently-used.xbel, geany.conf; options :
   # global_history.dat, bookmarks (links2 & MZ), sqlite*, history
   # (Vivaldi, Chromium)."
	BashS=" hic-et-nunc2.sh, CleanMTPaintHistory.sh, mc.sh,
   # gpl3.sh, sqlitemanager.sh (BarryK), visionner-avec-less4c.sh, etc.
   #";FiN="
   # aemenu & bcm (vovchik): murga-linux.com/puppy/viewtopic.php?t=107578
   #######################################################################"
	case "${LANG%_*}" in
	en)echo -e "\n   $TitrE\n   # Displays the Most Recently Used Files and Directories (MRUF|MRUD).
   # Usable within Puppy with most WM's and FM's. # For aemenu by
   ### (c) Christian L'Écuyer, alias « musher0 » (PuppyLinux forum),
   # Gatineau (Qc), Canada, end of Oct.-beg. of Nov. 2012.
   ## Edits: Oct. 15, Nov. 16 2013; June 11 2014, March 13 2015 (v. 0.3-0.4b)
   ### Aug. 31 - Sept. 28 2016, (v. 0.5 to 0.9.5.6)
   ### end of June - July 15 2017 (to v. 0.9.7.7).
   ## /usr/share/doc/MRUF-lst/gpl3.sh will display the licence (GPL3).\n   #
   # Required --
   # Exec.: $ExecS\n   # Data: $DonneeS
   # Bash Scripts: $BashS
   ################   References, credits and thanks:   #################
   # Icon: Puppus Dogfellow. ## Comm.: Mike_Walsh, Lazy_Puppy, 'MM'.
   # Idea: pekwm.org; openbox.org (thanks to stu91 for the info). $FiN\n
                     (Type 'Enter' to close this panel.)" ;;
     fr)echo -e "\n   $TitrE\n   # Affiche les répertoires et fichiers récemment utilisés. S'utilise
   # dans Puppy|Toutou avec la plupart des gest. de fen. et de fich.\n   #
   # Pour aemenu par (c) Christian L'Écuyer, alias « musher0 »
   # (forum PuppyLinux), Gatineau (Qc), Canada, fin oct. - début nov. 2012.
   ### Rév. : 15 oct., 16 nov. 2013; 11 juin 2014, 13 mars 2015 (v. 0.3 à 0.4b)
   ### 31 août - 28 sept. 2016 (v. 0.5 à 0.9.5.6)
   ### fin juin - 15 juillet 2017 (jusqu'à v. 0.9.7.7).
   ## /usr/share/doc/MRUF-lst/gpl3.sh affichera la license (GPL3).\n   #
   # Requis --
   # Exéc. : $ExecS\n   # Données: $DonneeS
   # Scripts en bash :$BashS
   ################   Réf., crédits et remerciements :   #################
   # Icône : Puppus Dogfellow. ## Obs. : Mike_Walsh, Lazy_Puppy, 'MM'.
   # Idée : pekwm.org; openbox.org (merci à stu91 pour l'info). $FiN\n
                    (Taper 'Entrer' pour fermer ce panneau.)" ;;
     esac;read ;; # Description

	*)# LANG=en_CA.utf8 # Uncomment this line to debug / test the script in English.
	cd $MRUFrep # Habillage par défaut & Variables
	[ ! -f Fonte ] && echo "OpenSans-Light" > Fonte;Caract="`head -1 $MRUFrep/Fonte`"
	[ ! -f Size ] && echo 12 > Size;Size="`head -1 $MRUFrep/Size`"
	[ ! -f Color ] && echo -e "bisque\nsnow" > Color
	Color1="`head -1 $MRUFrep/Color`";Color2="`tail -1 $MRUFrep/Color`"
	if [ ! -f SqlitE ];then
		[ -f /usr/local/bin/sqlitemanager.sh ] && echo "/usr/local/bin/sqlitemanager.sh" > SqlitE
	fi
	[ -f SqlitE ] && SqlitE="`head -1 $MRUFrep/SqlitE`"
# For file managers # Thanks to Mike Walsh for this suggestion. # Sept. 5 2016
	[ ! -f FileMan ] && echo rox > FileMan;FM="`head -1 $MRUFrep/FileMan`"
	SpaN2="</span></span>"

# Construction du menu # En-tête
	echo -e "### aemenu ###\n# This is a dynamic file! # Ce fichier change tout le temps !
# Do not edit directly.  # # Ne pas éditer directement.\n# aemenu pour MRUF-lst.* \n" > /tmp/en-tete
case "${LANG%_*}" in fr)
		DOCREC="Documents récents";DaT="`date '+ %a. %d %b., %R '`";LiC=Licence ;;
	en|*)
		DOCREC="Recent Documents";DaT="`date '+ %a. %b. %d , %R '`";LiC=License ;;
esac
echo -e "cmd \"   <span color='$Color2'><span underline='low'><i>$DaT</i></span></span>\" \"/usr/local/bin/hic-et-nunc2.sh;$MRUF\"
# cmd
menu \"<span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>$DOCREC</i>$SpaN2\"
# ${LANG%_*}" >> /tmp/en-tete

# Corps #
	if [ ! -f $corps -o "`grep -ow ${LANG%_*} /tmp/en-tete`" = "" -o "`ls -Algo $XBelChecK | awk '{ print $3 }'`" != "`cat XbelSize`" -o "`ls -AlgoH /usr/local/bin/$MRUFv | awk '{ print $3 }'`" != "`cat ScriptSize`" ];then
	# Menu existence, which language, freshness and script editing detection.
		DepuiS="`echo $DaT | awk '{ print $NF }'`"
# Attente
		case "${LANG:0:2}" in fr)TXTMSG3="
Le menu doit être mis à jour.
... Merci de votre patience ...
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
Si les couleurs ne conviennent pas, allez
à 'Param.->Habillage->Jeux de couleurs'." ;;
			en|*)TXTMSG3="
The menu must be updated.
... Thanks for waiting ...
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
If the colors are not satisfactory, use
'Param.->Dress-up->ColorSchemes'." ;;
		esac

		bcm -u /usr/local/share/pixmaps/mrudicon2-48x-trnsprnt.png -a 1 -g c:c -d 5 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='LiberationSerif Bold Italic 18' color='$Color1' gravity='north' gravity_hint='line'>$TXTMSG3</span>" 2>/dev/null &
		echo . > $corps

# Variables
		source /usr/local/share/MRUF/vars.GEN
		[ ! -L $XBel ] && ln -s /root/.local/share/recently-used.xbel $XBel

		case "${LANG%_*}" in
			fr)source /usr/local/share/MRUF/vars.FR ;;
			en|*)source /usr/local/share/MRUF/vars.EN ;;
		esac # See file /usr/share/doc/MRUF-lst/MRUF-langues.txt to implement other languages.

# Fonctions
		RplaciT () { replaceit --input=${j} "/initrd/mnt/dev_save" "/mnt/home"; }
##
		EnD  () { echo end >> $corps; }
##
		BacKuP () { BkP="";BkP="cp -f --backup ${j} ${j}.bkp";
		echo -e "cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
	cmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;rm -f ${j};rm -f $corps;$MRUF\"" >> $corps
		EnD; }
##
		dIRs () {
		dir="";for dir in `cat ${j}`;do
			[ -d "${dir#*//}" ] && echo "cmd \"${dir#*//}\" \"$FM '${dir#*//}'\"" >> $corps
		done; }
##
		tITRe () { echo -e "menu \"$SpanSizE2<i> ${j}</i>$SpaN2\"\n$LignESpaN" >> $corps; }
##
		MRUD () { k="";k="${j}";j="";j="/tmp/MRUFprog";
		RplaciT
		j="";j="${k}";i="";for i in `cat /tmp/MRUFprog`;do # | sort -u
			[ -f "$i" ] && echo "cmd \"$i\" \"default${j}editor '$i';$MRUF\"" >> $corps
		done
		echo "$LignESpaN" >> $corps
		j="";j="⚫ M. R. U. Dirs";tITRe
		> /tmp/MRUDprog
		i="";for i in `cat /tmp/MRUFprog | grep -v recent_files`;do
			[ -f "$i" ] && dirname $i >> /tmp/MRUDprog
		done
		k="";k="${j}";j="";j="/tmp/MRUDprog2"
		sort -u /tmp/MRUDprog > ${j}
		RplaciT
		dIRs;j="${k}";EnD; }
##
		DefEdVieW () {
		echo -e "$LignESpaN\n   cmd \"   default${j}editor\" \"default${j}editor;$MRUF\"
	cmd \"   default${j}viewer\" \"default${j}viewer;$MRUF\"" >> $corps
		EnD; }
##
		FinD () { find "$DiR" -maxdepth 6 -mindepth 4 -name "$NamE" -mtime 0 2>/dev/null; }
##
		FilHndlR () {
			if [ -f "${file#*//}" ];then
				if [ "`file -b ${file#*//} | awk '$0 !~ /text|image|package|compression|Squashfs/'`" ];then
					echo "cmd \"${file#*//}\" \"xdg-open '${file#*//}';$MRUF\"" >> $corps
				else
					i="";for i in text image;do
						[ "`file -b ${file#*//} | awk '/'${i}'/'`" ] && echo "cmd \"${file#*//}\" \"default${i}viewer '${file#*//}';$MRUF\"" >> $corps
					done
					[ "`file -b ${file#*//} | awk '/package|compression/'`" ] && echo "cmd \"${file#*//}\" \"/usr/local/apps/UExtract/AppRun '${file#*//}';$MRUF\"" >> $corps
					[ "`file -b ${file#*//} | awk '/Squashfs/'`" ] && echo "cmd \"${file#*//}\" \"sfs_load '${file#*//}';$MRUF\"" >> $corps
				fi
			fi; }
##
		BkPLine (){ BkP="";BkP="cp -f --backup ${k} ${k}.bkp";
		echo "cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"" >> $corps; }
##
		EffacE () { echo "cmd  \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"$BkP;Clean${j}History.sh;rm -f $corps;$MRUF\"" >> $corps; }
##
		gMplyR () { j="";j="${k}/mplayer.lst";
			> ${j}
			gui="";for gui in gui.${ending};do
				[ "`wc -l < $gui`" -gt "0" ] && cat $gui >> ${k}/mplayer.lst
				RplaciT
			done
			sort -u ${j} | head -n 7 > /tmp/MRUFprog; }
###
#### We build! | On construit ! :-)
		LC_ALL=C # for speed
		echo "$LignESpaN" >> $corps
		j="";j="⚫ ' xbel '";tITRe
#
		j="";j="⚫ $FiL";tITRe
		file="";for file in `awk -F"\"" '/href/ && $2 !~ /'${PicS}'|\.sh/ { print $2 }' $XBel | tail -n 14`;do
			FilHndlR
			dirname "${file#*//}" >> /tmp/dir-catalog # Prép. pour M.R.U.D., 3e ci-dessous.
		done;echo -e "$LignESpaN
		cmd \"$SpanSizE3<i>⚫ ($FichRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # General files
#
		j="";j="⚫ Images";tITRe
		file="";for file in `awk -F"\"" '$2 ~ /'${PicS}'/ { print $2 }' $XBel | tail -n 14`;do
			FilHndlR
		done;echo -e "$LignESpaN
		cmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Images
#
		j="";j="⚫ $APPS";tITRe
		for app in `awk -F";" '$1 ~ /exec/ { print $2 }' $XBel | awk '{ print $1 }' | sort -u`;do
			[ "`which $app`" ] && echo "cmd $app \"$app;$MRUF\"" >> $corps
		done;echo -e "$LignESpaN
		cmd \"$SpanSizE3<i>⚫ ($ApPRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Apps
#
		j="";j="⚫ Scripts";tITRe
		awk -F"\"" '$2 ~ /\.sh/ && $2 !~ /MRUF/ { print $2,$(NF-1) }' $XBel | awk -F"T" '{ print $1 }' | sort -u -r -k 2 | head -n 14 | awk '{ print $1 }' > /tmp/scripts.xbel
		while read line;do
			echo "cmd ${line##*/} \"defaulttexteditor $line\"" >> $corps
		done < /tmp/scripts.xbel
		echo -e "$LignESpaN
		cmd \"$SpanSizE3<i>⚫ (14 $ScrpTRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # Scripts
#
		j="";j="⚫ M. R. U. Dirs";tITRe
		j="";j="/tmp/dir-catalog";RplaciT
		k="";k="${j}";j="";j="/tmp/dir-catalog.uniq"
		sort -u ${k} > ${j}
		dIRs;echo -e "$LignESpaN
		cmd \"$SpanSizE3<i>⚫ ($DiRRecnt [' xbel '])</i>$SpaN2\" \"\"" >> $corps
		EnD # MRUD
#
		j="";j="$XBelsrc";echo -e "$LignESpaN" >> $corps
		BacKuP # End of general section | Fin de la section générale | xbel.
###
		j="";j="⚫ URLs";tITRe # URLs
##
		NamE="global_history.dat";DiR="/root/.opera";OprAHsT="`FinD`" # 1st we look here.
		if [ "$OprAHsT" = "" ];then DiR="/mnt";OprAHsT="`FinD`";fi # then here.
		if [ "$OprAHsT" != "" ];then # If we have something, we create the sub-menu.
			j="";j="⚫ Opera-12.x";tITRe
			http="";for http in `awk '/http/ && $1 !~ /'${aVOId}'/' $OprAHsT | head -n 14`
				do echo -e "cmd \"$http\" \"defaultbrowser '$http';$MRUF\"" >> $corps
			done # Vérifier :	echo "cmd \"opera:history\" \"opera opera:history\"" >> $corps
			BkP="cp -f --backup $OprAHsT $OprAHsT.bkp"
			echo -e "cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
			cmd \"$DSeaGR<i> ⚫ $EFF  </i>$SpaN2\" \"[ "`ps | awk '$4 ~ /opera/'`" = "" ] && $BkP && rm -f $OprAHsT;rm -f $corps;$MRUF\"
			$LignESpaN" >> $corps # Erasing works only if opera is not loaded.
			echo "cmd \"opera\" \"opera;$MRUF\"" >> $corps
		EnD;fi # End, opera-12.x section
##
		k="/root/.links/bookmarks.html";if [ -f $k ];then # If we have Links2.
			j="";j="⚫ Links2";tITRe
			http="";for http in `awk -F"\"" '$2 ~ /http/ && $2 !~ /'${aVOId}'/ { print $2 }' $k | tail -n 14`;do
			# | sort -u
				echo "cmd \"$http\" \"defaulthtmlviewer $http;$MRUF\"" >> $corps
			done
			echo -e "cmd \"$SpanSizE3<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"
$LignESpaN\ncmd \"defaulthtmlviewer\" \"defaulthtmlviewer\"" >> $corps
		EnD;fi # links2 # pseudo-history
##
		NamE="places.sqlite";DiR="/root/.mozilla";PlacE="`FinD`" # same reasoning as for opera
		if [ "$PlacE" = "" ];then DiR="/mnt";PlacE="`FinD`";fi
		if [ "$PlacE" != "" ];then
			j="";j="⚫ MZ";tITRe
			MZ="`find / -maxdepth 6 -name bookmarks.html | grep -E -v "sda|links" | tail -n 1`"
			# Fallback if we don't have a sql program to process the places.sqlite file.
			if [ "$MZ" != "" ];then # Line below: Unix timestamp for today, less 30 days.
				a="`date +%s`";let b=30*24*60*60;let c=$a-$b
			http="";for http in `awk -F"\"" '$2 ~ /http/ && $2 !~ /'${aVOId}'/ && $6 > '${c}' { print $2 }' $MZ | tail -n 14 | sort -u`;do
				echo "cmd \"$http\" \"defaultbrowser $http;$MRUF\"" >> $corps
			done
			echo -e "cmd \"$SpanSizE3<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"" >> $corps
			fi # End, MZ bookmarks sub-section.
#
			if [ -f $MRUFrep/SqlitE ];then # Won't kick in if no sqlite is detected.
				echo -e "$LignESpaN\n   cmd \"places.sqlite\" \"$SqlitE $PlacE;$MRUF\"
			cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $PlacE $PlacE.bkp" >> $corps
			fi # End, places.sqlite sub-section.
			echo -e "$LignESpaN\ncmd \"  $MZbr\" \"seamonkey || firefox || palemoon\"" >> $corps
		EnD;fi # End, MZ section
##
		ViV="`find / -maxdepth 5 -name vivaldi-bin | head -1`";ViV="`dirname $ViV`"
		if [ "$ViV" != "" ];then
			j="";j="⚫ Vivaldi";tITRe
			echo -e "cmd \"$HistoriQ\" \"cd $ViV;./vivaldi --enable-grouped-history --user-data-dir=profile vivaldi://history;MRUF\"" >> $corps
			pDH="profile/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo "cmd \"$HistoriQ (local)\" \"cd $ViV;$SqlitE $pDH;$MRUF\"
			cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cd $ViV;cp -f --backup $pDH $pDH.bkp\"" >> $corps
		EnD;fi # End, Vivaldi section
##
		if [ "`which chromium`" ];then # Based on peebee's chromium-44 sfs.
			j="";j="⚫ Chromium";tITRe
			echo -e "cmd \"$HistoriQ\" \"chromium chrome://history;$MRUF\"" >> $corps
			cDH="/root/.config/chromium/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo "cmd \"$HistoriQ  (local)\" \"$SqlitE $cDH;$MRUF\"
			cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $cDH $cDH.bkp;$MRUF\"" >> $corps
		End

		EnD;fi # Pourquoi 2 fois ? # End of Chromium section.
##
		echo -e "$LignESpaN\ncmd \"  defaultbrowser\" \"defaultbrowser;$MRUF\"
		cmd \"  defaulthtmlviewer  \" \"defaulthtmlviewer;$MRUF\"" >> $corps
		EnD # URLs
###
	j="";j="⚫ $APPS";tITRe
		k="";k="/root/.config/geany/geany.conf";if [ -f ${k} ];then # Skipped if no Geany.
			j="";j="⚫ Geany";tITRe
			cd "${k%/*}"
			grep t_files= "${k##/*/}" | tr ";" "\n" | head -n 14 > /tmp/MRUFprog # | sort -u
			echo -e "cmd \"$SpanSizE3<i>⚫ (Textes récents [' geany '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="text";MRUD
			echo "$LignESpaN" >> $corps
			BkPLine
			j="";j="Geany";EffacE
			j="";j="text";DefEdVieW # Erasing works only if program not running.
		fi # End, Geany section
###
		if [ -f /usr/bin/gmplayer ];then
			MplayeR="gmplayer" # Tester aussi avec smplayer :
			# [ -f /usr/bin/gmplayer ] && MplayeR="gmplayer" || MplayeR="smplayer"
			j="";j="⚫ gMPlayer";tITRe
			echo -e "cmd \"$SpanSizE3<i>⚫ $MPlyRFils</i>$SpaN2\" \" \"" >> $corps
			k="";k="/root/.mplayer";cd ${k}
			ending="";ending="url";gMplyR # Radios et autres # Aussi gui.pl? Non.
			media="";for media in `cat /tmp/MRUFprog`;do
				echo "cmd \"${media##*/}\" \"$MplayeR $media;$MRUF\"" >> $corps
			done
			echo "$LignESpaN" >> $corps
			j="";j="⚫ M. R. U. Dirs";tITRe
			ending="";ending="history";gMplyR  # For directories
			media="";for media in `cat /tmp/MRUFprog`;do
				echo "cmd \"${media##*/}\" \"rox $media;$MRUF\"" >> $corps
			done;EnD
			echo -e "$LignESpaN
			cmd  \"$DSeaGR<i> ⚫ $EFFs  </i>$SpaN2\" \"CleanMPlayerHistory.sh;rm -f $corps;$MRUF\"
			cmd  \"$DSeaGR<i> ⚫ $EDTs  </i>$SpaN2\" \"defaulttexteditor ${k}/gui.history ${k}/gui.url;$MRUF\"
			$LignESpaN" >> $corps
			for exec in audio media video;do
				[ -f /usr/local/bin/default${exec}player ] && echo -e "cmd \"  default${exec}player  \" \"default${exec}player;$MRUF\"" >> $corps
			done;EnD
		fi # End, MPlayer section
###
		k="";k="/root/.mtpaint"
		if [ -f ${k} ];then # Skipped if no mtpaint.
			j="";j="⚫ Mtpaint";tITRe
			awk '$1 ~ /^file/ && $0 !~ /MRUF/ { print $3 }' ${k} | head -n 14 | sort -u > /tmp/MRUFprog
			echo -e "cmd \"$SpanSizE3<i>⚫ ($ImGRecnt [' mtpaint '])</i>$SpaN2\" \" \"" >> $corps
			j="";j="image";MRUD
			echo "$LignESpaN" >> $corps
			BkPLine
			j="";j="MTPaint";EffacE # Erasing works only if program not running.
			j="";j="image";DefEdVieW
		fi # End, MtPaint section
		echo "$LignESpaN" >> $corps
		EnD
###
		j="";j="⚫ bash+Syst.";tITRe
#
		k="";for k in bash-bash_history less-lesshst noX_console-history sqlite-sqlite_history;do
			j="";j="⚫ ${k%-*}";tITRe
			j="";j=".${k#*-}"
			[ -f /root/"${j}" ] && echo "cmd \"    $HIST\" \"/opt/local/bin/visionner-avec-less.sh /root/${j};$MRUF\"" >> $corps
			BacKuP
		done
#
		j="";j="⚫ ' xerrs.log '";tITRe
		echo "cmd \"    xerrs.log\" \"/opt/local/bin/visionner-xerrs_log-2c.sh;$MRUF\"" >> $corps
		j="";j="/tmp/xerrs.log";BacKuP
#
		j="";j="⚫ ' Xorg.log '";tITRe
		j="";j="/var/log/Xorg.0.log"
		echo "cmd \"    Xorg.log\" \"/opt/local/bin/visionner-avec-less.sh ${j};$MRUF\"
		cmd \"$DSeaGR<i> ⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${j} ${j}.bkp;$MRUF\"" >> $corps
#
		echo -e "end\n$LignESpaN\ncmd \"   console\" \"console-hdr.sh;$MRUF\"
	cmd \"   less\" \"cd /usr/local/bin;/opt/local/bin/visionner-avec-less.sh NQuelTxt;$MRUF\"
	cmd \"   $InviT\" \"killall X\"" >> $corps
		EnD # Terminal
###
		j="";case "${LANG:0:2}" in fr)j="⚫ 14 derniers" ;;
			en|*)j="⚫ Last 14" ;;
		esac;tITRe
		j="";case "${LANG:0:2}" in fr)j="⚫ paquets" ;;
			en|*)j="⚫ packages" ;;
		esac;tITRe
		cd /root/.packages
		ls -Algot *.files | head -n 14 | awk -F. '{ print $1 }' | awk '{ print $4,$5,$7 }' > /tmp/liste-PPM
		while read line;do
			echo "cmd \"${line% *}--${line##* }\" \"/opt/local/bin/visionner-avec-less.sh /root/.packages/${line##* }.*.files\"" >> $corps
		done < /tmp/liste-PPM
		echo "$LignESpaN" >> $corps
		EnD # End, 10 last packages installed by petget
#
		j="";case "${LANG:0:2}" in fr)j="⚫ Mes docs" ;;
			en|*)j="⚫ My Docs" ;; ####
		esac;tITRe
		cd /root/my-documents
		ls -Algot | grep -v -E "lrw|drw" | head -n 15 | awk '{ print $4,$5,$7 }' > /tmp/liste-Mes-docs
				while read line;do
				if [ "$line" != "" ];then
					echo "cmd \"${line% *}--${line##* }\" \"rox /root/my-documents/${line##* }\"" >> $corps
				fi
		done < /tmp/liste-Mes-docs
		echo "$LignESpaN" >> $corps
		EnD # End, 14 last personal docs.
		echo "$LignESpaN" >> $corps
		EnD # End, "14 Last" section
		echo "$LignESpaN" >> $corps
		EnD
#
###
		echo -e "$SeaGreeN" >> $corps
		j="";j="                $HlP";tITRe
		echo -e "cmd \"$SpanSizE2<i>   MRUF-lst (Description)</i>$SpaN2\" \"urxvt -fn xft:Monaco:pixelsize=14:antialias=true:hinting=true -bg linen -fg grey15 -g 80x30 -b 20 -cr orange -bd orange3 +uc -bc +sb -e MRUF-lst h;$MRUF\"\n$LignESpaN" >> $corps
	#
		for ligne in "$LigN1" "$LigN2" "$LigN3";do
			echo "cmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done;echo -e "$LignESpaN\n	cmd \"$SpanBolD<i>$LigN7</i>$SpaN2\" \" \"
	$LignESpaN\n	cmd \"$SpanBolD<i>$LigN6</i>$SpaN2\" \" \"" >> $corps
		[ "`which chromium`" ] && echo -e "$LignESpaN\n	cmd \"$SpanBolD<i>$MayNoTLanD</i>$SpaN2\" \" \"" >> $corps
		[ -f /usr/local/bin/MenuDefautPlus ] && echo -e "$LignESpaN\n	cmd \"  MenuDefautPlus\" \"MenuDefautPlus\"" >> $corps
		echo -e "$LignESpaN\n	cmd \"   $LiC\" /usr/share/doc/MRUF-lst/gpl3.sh
		$LignESpaN" >> $corps
		EnD # Help
###
		j="";j="              Param.";tITRe
		j="";j="   $HabiT";tITRe
		j="";j="  $ClRs";tITRe
		cd $MRUFrep;for i in `ls -1 ColorS*`;do
			ColorA="`head -1 $i`";ColorB="`tail -1 $i`"
			echo "cmd \"<span fgcolor='$ColorA'><i>  $SchM</i><span fgcolor='$ColorB'><i> $i </i>$SpaN2\" \"cat ${i} > Color;rm -f $corps;$MRUF\"" >> $corps
		done;EnD # Colors
#
		j="";j="  $Taille";tITRe
		for i in 8 9 10 11 12 13 14 15 16 17;do
			echo "cmd \"      $i\" \"echo $i > $MRUFrep/Size;rm -f $corps;$MRUF\"" >> $corps
		done;EnD # Sizes
#
		echo -e "$LignESpaN\n   cmd \"  GTK chtheme\" \"gtk_chtheme_wrapper;Get-Gtk-Theme.sh;exit\"
   cmd \"  $FixColors\" \"Get-Gtk-Theme.sh;exit\"" >> $corps # $MRUF ?
		EnD # Dress-up
###
		j="";j="   $FileMan";tITRe
		for flmngr in MidnightCommander_mc.sh PcMan_pcmanfm ROX-Filer_rox Xfe_xfe;do
# Add any FM that you are using in your Puppy by following above pattern.
			[ "`which ${flmngr#*_}`" ] && echo "cmd \"   ${flmngr%_*}\" \"echo ${flmngr#*_} > $MRUFrep/FileMan;$MRUF\"" >> $corps # < which > to prevent accidents.
		done
		echo "cmd \"$DSeaGR<i> ⚫ $ChoiX  </i>$SpaN2\" \" \"
		$LignESpaN\n" >> $corps
		EnD # FileManagers
		echo "$LignESpaN" >> $corps
		EnD # params.
##
		echo -e "cmd \"       <span color='$Color2'>━━━━━━━━</span>\" \"$MRUF\"
		cmd \"    $mAj $DepuiS \" \" \"
		cmd \"$DSeaGR<i> ⚫  $RefresH </i>$SpaN2\" \"mv -f $corps $corps.bkp;$MRUF\"" >> $corps
###
# Pour déboguer, enlever le « # » ci-dessous. / To debug, remove the "#" below.
		echo "cmd \"  <~- $EDT\" \"defaulttexteditor /tmp/recents\"" >> $corps
#
		i="";for i in /tmp/dir-catalog* /tmp/MRUF* /tmp/MRUD*;do rm -f $i 2>/dev/null;done
# Nettoyage / Clean-up
		ls -Algo $XBelChecK | awk '{ print $3 }' > $MRUFrep/XbelSize # Size stamps for xbel file
		ls -AlgoH /usr/local/bin/$MRUFv | awk '{ print $3 }' > $MRUFrep/ScriptSize # and this script.
### Fin du / End of / menu
	fi
###
	replaceit --input=$corps "/initrd/mnt/dev_save" "/mnt/home" # Retouches pour
	replaceit --input=$corps "/initrd/mnt/tmpfs/tmp" "/tmp" # raccourcir les lignes. /
	replaceit --input=$corps "/mnt/sda1/DpupStretch-7.0b/yaya/my-documents" "/root/my-documents"
	# Touch-ups to shorten lines.

	cat /tmp/en-tete $corps > /tmp/recents # Action
	LC_ALL="" # Brings LC_ALL back to default value.

	aemenu-pango -rc /tmp/recents 2>/dev/null ;; # Affichage / We show the menu.
esac ### # set +xe
