#!/bin/sh
# pinstall.sh # pour / for MRUF-lst
# (c) Christian L'Écuyer, alias « musher0 » (forum PuppyLinux),
#     ... Gatineau (Qc), Canada, 6 sept. 2016. GPL3. ...
#  /usr/share/doc/MRUF-lst/gpl3_fr.sh
# Will display the licence. / Affichera la license.
####
fc-cache -r # Pour incorporer les polices /
# To incorporate fonts / OpenSans-Light & Monaco.

# Icône MRUF # à déposer sur le bureau ROX.
# MRUF icon # to be placed on the ROX desktop.
####
[ "`ps | grep pwidgets`" ] && PwidgetS=1 && killall -q conky
# Remove any running pwidgets.

# Prepare
cd /root/Choices/ROX-Filer
cp -f PuppyPin PuppyPin.cdr # Copie de réserve / Back-up

HauTPPin="`wc -l < PuppyPin`";HauTPPin="`expr $HauTPPin - 1`"
head -n $HauTPPin PuppyPin > PuppyPin.tmp

# Measure screen
VertIcN="`xwininfo -root | awk '$1=="Height:" { print $2/2}'`"
HorizIcN="`xwininfo -root | awk '$1=="Width:" { print $2/2}'`" # 8*7
# En plein milieu de l'écran. / Right in the middle of the screen.
EtiqT="MRUF-lst"

# Create new PuppyPin
echo "<icon x=\"$HorizIcN\" y=\"$VertIcN\" label=\"$EtiqT\">/usr/share/applications/MRUF-lst.desktop</icon>
</pinboard>" >> PuppyPin.tmp

# Enable
mv -f PuppyPin.tmp PuppyPin
rox -p /root/Choices/ROX-Filer/PuppyPin

# Restore pwidgets if they were active.
[ $PwidgetS -eq 1 ] && /root/Startup/0_show_widgets
