#!/bin/sh
# /usr/local/bin/CleanGeanyHistory.sh
# (c) Christian L'Écuyer, alias « musher0 » (forum PuppyLinux),
# ... Gatineau (Qc), Canada, 19 sept. 2016
#  /usr/share/doc/meteo-tradFR/gpl3_fr.sh affichera la license.
####
cd /root/.config/geany
if [ "`ps | awk '$4 ~ /geany/'`" = "" ];then
	cp -f --backup geany.conf geany.conf.bkp
	replaceit --input=geany.conf --wholeline recent_files= recent_files=
else
	MRUFrep="/usr/local/share/MRUF"
	Caract="`head -1 $MRUFrep/Fonte`";Size="`head -1 $MRUFrep/Size`"
	Color1="`head -1 $MRUFrep/Color`";Color2="`tail -1 $MRUFrep/Color`"

	case "${LANG:0:2}" in
		fr)TXTMSG3=" On ne peut effacer l'historique d'une
appplication pendant qu'elle est active." ;;
		*)TXTMSG3="The history of an application cannot
 be erased while the app is active." ;;
	esac
	yaf-splash -border true -bw 10 -bd black -fg $Color1 -bg $Color2 -bg_gradient true -font $Caract -fontsize $[$Size+4] -timeout 10 -margin 7 -outline 0 -text "$TXTMSG3" 2>/dev/null &
fi # Erasing works only if program not running.

